#include <stdio.h>
#include <math.h>
#define n1 8640
#define n2 8200
#define bok 48.
#define n60 99.
#define t_cosmos 2.

double a8[8],b8[8],pi,cx,cy;
char  head[72][80],c1[14],c2[14];
char  f1[30],f2[30],f3[30],c[80];
float ux[50000],uy[50000],um[50000]; int un[50000],nu;
float bm[30000],bx[30000],by[30000],bz[30000]; int bn[30000],nb;
char  b_fit[n2][n1],b49[30000];
float d1[50000],d2[50000],d3[50000];      // DAO sky,mag,err
float cali,gain,seei,rdno;
float s2,s3,s4,s5,s6,s7,s8,s9,sb,sc,sd,se; int sa;   //SEX
float onesec2=(1./.454)*(1./.454);     // dueto ra->x,ascii_bin,calucalte err
                                       // dr973 1", here 0.99"
sexjob(float x)
{
  int k;
  FILE *fp,*fp1;
  fp =fopen("/vega2/rhbin/uefault.sex","r");
  fp1=fopen("default.sex","w");
  k=(x-1.)*10+.5; k+=48;
l10:
  fgets(c,80,fp); if(feof(fp))goto l20;
// set DETECT_MINAREA	20 ===> DETECT_MINAREA	15       20120210
  if(c[0]=='D'&&c[6]=='_'&&c[7]=='M'){c[15]='1'; c[16]='5'; }
  if(c[0]=='D'&&c[6]=='_'&&c[8]=='H')c[16]=k;
  if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain); c[10]=9;}
  if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",seei);c[17]=9;}
  fputs(c,fp1); goto l10;
l20:
  fclose(fp1); fclose(fp);
  sprintf(c,"sex %s",f2); system(c);
  k=x*10+0.5;
  sprintf(c,"mv test.cat test%d.cat",k); system(c);
}

main(int ac,char **av)
{
  int    i,j,k,l,lm;
  float  x,y,z,r,zz;
  char   a[220],b[170],t[80],c37=37;
  double alpha,delta,dx,dy;
  FILE   *fp,*fpp, *fp1,*fp2;
  int    i5,ka,kb,kc,ja,jb;
  long long a64;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;

  if(ac<2){
    printf("\n\t******** 4key (15 points higher background) *********\n");
    printf("\n\t  CORE: positon mainly come from SL\n");
    printf("\n\t Usage: 4key_1 filename     20130420\n");
    printf("\n\t NOTICE need file: filename.fit & b_filename.fit\n\n");
   printf(" 1. automatic processing pipeline2 job, not answer any question.\n");
   printf(" 2. copy *.par, default.* to default_directory, put GAIN SEEING.\n");
   printf(" 3. batch job:\n\n");
    exit(0);
  }
  strcpy(f1,av[1]);
  k=nindex(f1,"."); if(k>0)f1[k]=0;         // f1=a*
  strcpy(f2,f1); strcat(f2,".fit");        
  fp=fopen(f2,"rb"); if(fp==0){ printf("\tfile not found: %s\n",f2); exit(0); }
  fread(head,72,80,fp); fclose(fp);
  sscanf(&head[3][20],"%d",&i);
  sscanf(&head[4][20],"%d",&j);
  if(i!=n1 || j!=n2){ printf("\t not a 8640*8200 pixel file\n"); exit(0); }
  k=indexpos(head,"CALIA73 ",72);
  if(k==72){ printf("\t not a cali_A73  file: %s\n",f2); exit(0); }
  sscanf(&head[k][15],"%f",&cali);
  k=indexpos(head,"SEEING  ",72); 
  if(k==72){ printf("\tI cannot find seeing in file: %s\n",f2); exit(0); }
  sscanf(&head[k][15],"%f",&seei);
  gain=1.9; rdno=9.;
  k=indexpos(head,"A81     ",72);
  if(k==72){ printf("%s not coordinating!\n",f2); exit(0); }
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%lf",&a8[i]);
  xytoad(a8,b8);

  system("cp /vega2/rhbin/bok.par .");
  system("cp /vega2/rhbin/headcat1.par .");          // version 1
  system("cp /vega2/rhbin/uefault.param default.param");
  system("cp /vega2/rhbin/uefault.conv default.conv");
  system("cp /vega2/rhbin/uefault.nnw default.nnw");
  sexjob(1.4);
  sexjob(1.0);
  sprintf(c,"slim1   b_%s",f2); system(c);     // b_a*.fit --> bb_a*.fit	
  sprintf(c,"slim2 %s 1.4",f2); system(c);     // test10+test14--->test.cat 	
// test.cat -- (del 15 edge, best+cali, number 0,3,6,7) --> a*.sex
  fp=fopen("test.cat","r"); if(!fp){ printf("test.cat not found!\n");exit(0);}
  sprintf(f2,"%s.sex",f1); fp1=fopen(f2,"w");
  i=k=0;
l10:
  fgets(a,220,fp); if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;  
  sscanf(a,"%d",&j); j/=10000; if(j==0)j=1;
  sscanf(&a[66],"%f %f",&x,&y); 
  if(x<15. || y<15. || x>=n1-15 || y>=n2-15){ k++; goto l10; }
  sscanf(&a[47],"%f",&z); z+=cali; if(z>90.){ k++; goto l10; }
  fprintf(fp1,"%d %8.4f %s",j,z,&a[57]);
  bx[i]=x; by[i]=y; bn[i]=-j; bm[i]=z;
  i++; if(i>=30000)i--;
  goto l10;
l20:
  fclose(fp); fclose(fp1); nb=i;
  printf("==> %s   %d -%d = %d\n",f2,nb+k,k,nb);
// get main.usl
  toms2(a8[6]/cx,c1,1); toms2(a8[7]/cy,c2,0);
  sprintf(a,"dr973r %s %s 65.4 main.usl 23.0 !",c1,c2);  system(a);
  printf("==> %s\n",f2);
  fp=fopen("main.usl","r"); i=j=k=0;
l30:
  fgets(a,220,fp); if(feof(fp))goto l40;
  if(a[0]=='#')goto l30; k++;
  a[18]=a[31]=0;
  chs(&a[6],&alpha,1); chs(&a[19],&delta,0);
  rad_xy(a8[6],a8[7],alpha,delta,&dx,&dy,1,0);
  if(dx<15. || dy<15. || dx>=n1-15 || dy>=n2-15){ j++; goto l30; }
  ux[i]=dx; uy[i]=dy; un[i]=k;
  sscanf(&a[52],"%f",&um[i]);
  i++; if(i==50000)i--;
  goto l30;
l40:
  fclose(fp); nu=i; 
  printf(" < 23(r) usl: %d - %d(out of frame) = %d\n",nu+j,j,nu);
// 1-50000,main.usl;  50001-60000, supply.usl; 60001- ber alone
// nb=a*.sex line, nu ! =main.usl line;
// bn[]=-1,-2,  -3,-4,-5,  -6,-7;  un[]=main.usl_number;
// if match, bn[]=liu_shui_hao;
  l=0;
  for(i=0;i<nb;i++){
    x=bx[i]; y=by[i]; r=onesec2;
    for(j=0;j<nu;j++){
      z=(x-ux[j])*(x-ux[j])+(y-uy[j])*(y-uy[j]);    
      if(z<r){ r=z; k=j; }
    }
    if(r<onesec2){ bn[i]=k; l++;
      z=sqrt(r); bz[i]=z*0.454;
//    printf("%8.2f%8.2f %8.2f%8.2f %5.2f\n",x,y,ux[k],uy[k],z*0.454);
    }
  } 
  printf("bertin:  %d matched, %d left for judge\n",l,nb-l);
  lm=l;
// delete n_ber pointer to same usl
  l=0;
  for(i=0;i<nb;i++){
    if(bn[i]<0)continue;
    for(j=i+1;j<nb;j++)if(bn[i]==bn[j]){
      k=bn[i];
//    printf("SL: %8.2f%8.2f %6.2f\n",ux[k],uy[k],um[k]),
//    printf("i:  %d %8.2f%8.2f %6.2f %6.2f\n",i,bx[i],by[i],bm[i],bz[i]); 
//    printf("j:  %d %8.2f%8.2f %6.2f %6.2f\n",j,bx[j],by[j],bm[j],bz[j]); 
      k=i; if(bz[i]<bz[j])k=j;
      bm[k]=um[bn[i]];         // tmp save
      b49[k]=bn[k];  bn[k]=-90;    l++;          // start from 49001
//    printf("delete: %d\n",k);
      break; 
    }
  }

  printf("%d double_source pointer a usl, put to 49001\n",l);
  fp=fopen("supply.usl","w");
  i5=49001; l=0;
  for(i=0;i<nb;i++)if(bn[i]==-90){
    dx=bx[i]; dy=by[i];
    xy_rad(a8[6],a8[7],dx,dy,&alpha,&delta,1,0);
    toms2(alpha,c1,1); toms2(delta,c2,0);
    sprintf(t,"sla731 %s %s %c",c1,c2,c37);
    fpp=popen(t,"r"); fgets(a,220,fpp); pclose(fpp);
    a[18]=a[31]=0;
    chs(&a[6],&alpha,1); chs(&a[19],&delta,0);  a[18]=a[31]=32;
    rad_xy(a8[6],a8[7],alpha,delta,&dx,&dy,1,0);
      if(dx<0 ||dx>=n1){ bn[i]=b49[i]; l++; continue; }   // err near 1"
      if(dy<0 ||dy>=n2){ bn[i]=b49[i]; l++; continue; }   // aviod catcul err
    fprintf(fp,"%5d %s",i5,&a[6]);
    un[nu]=i5; ux[nu]=dx; uy[nu]=dy; um[nu]=bm[i];
    bn[i]=nu;  nu++; i5++;
  }  
  if(l)printf("reduce %d 2_pointer 1\n",l);
// find deep usl
  j=0; i5=50001;
  for(i=0;i<nb;i++){
    if(bn[i]>=0 || bn[i]<-10)continue;
    dx=bx[i]; dy=by[i];
    xy_rad(a8[6],a8[7],dx,dy,&alpha,&delta,1,0);
    toms2(alpha,c1,1); toms2(delta,c2,0);
    sprintf(t,"sla731 %s %s $",c1,c2); 
    fpp=popen(t,"r"); fgets(t,80,fpp); pclose(fpp);
    sscanf(&t[61],"%d",&k);
    if(k){ sscanf(&t[66],"%f",&z); if(z==0.)z=k*0.001; } else z=0.;
    if(z>5.){ j++;
      sprintf(t,"sla731 %s %s %c",c1,c2,c37);
      fpp=popen(t,"r"); fgets(a,220,fpp); pclose(fpp);
      a[18]=a[31]=0;
      chs(&a[6],&alpha,1); chs(&a[19],&delta,0);  a[18]=a[31]=32;
      rad_xy(a8[6],a8[7],alpha,delta,&dx,&dy,1,0);
      fprintf(fp,"%5d %s",i5,&a[6]);
      if(dx<0 ||dx>=n1)dx=0;
      if(dy<0 ||dy>=n2)dy=0;
      un[nu]=i5; ux[nu]=dx; uy[nu]=dy; um[nu]=z;
      bn[i]=nu;  nu++; i5++; 
    } else bz[i]=z;                       // save area_usl_num
  } fclose(fp);
  printf("find deep usl: %d   supply.usl produced!\n",j);
  lm+=j;
  for(i=k=0; i<nb; i++)if(bn[i]<=0 && bn[i]>=-9)k++;
  printf("bertin matched %d   left  %d, usl: %d\nslim9",lm,k,nu); 
// slim9
  ka=kb=kc=ja=jb=k=0;
  for(i=0;i<nb;i++){
    if(bn[i]>=0 || bn[i]<-10)continue;
    if(bn[i]==-6 || bn[i]==-7){ ja++;
       if(bm[i]>20.){ ka++; bn[i]=-99;}
       continue;
    }
    if(bn[i]==-2 || bn[i]==-1){ kc++; continue; }
    if(bn[i]<=-3 && bn[i]>=-5){ 
      jb++; if(jb%100==1){ printf("."); fflush(stdout); }
      sprintf(t,"nmz_9 %s %7.2f %7.2f",f1,bx[i],by[i]); system(t);
      xliu(f1,1,&x);
      xliu(f1,2,&y);
      if(x>n60 || y>n60){                     // save weak object.
        if(x<n60/2)x=n60/2; if(y<n60/2)y=n60/2;
        if(x>y)z=x/y; else z=y/x;
        if(z>t_cosmos){ kb++; bn[i]=-99; }
      }
    }
  }
  printf("after judge\nsingle %d-%d=%d    double %d-%d=%d    triple %d\n",
    ja,ka,ja-ka,jb,kb,jb-kb,kc);
  printf("left bertin unmatched object: %d\n",ja-ka+jb-kb+kc);
// left add to un...
  i5=60001;
  for(i=0;i<nb;i++){
    if(bn[i]>=0 || bn[i]<-10)continue;
    un[nu]=i5; ux[nu]=bx[i]; uy[nu]=by[i]; um[nu]=bz[i]; 
    bn[i]=nu;  nu++; i5++;
  }
  printf("I will put %d_star to do dao_photo\n",nu);
// produce a*.coo a*.ap
  sprintf(f2,"%s.coo",f1);
  fp=fopen(f2,"w");
  fprintf(fp," NL   NX   NY  LOWBAD HIGHBAD  THRESH");
  fprintf(fp,"     AP1  PH/ADU  RNOISE    FRAD\n");
  fprintf(fp,"  1 8640 8200   0.1 60000.0   22.76   10.00");
  fprintf(fp,"%8.2f%8.2f    10.00\n\n",gain,rdno);
  for(i=0;i<nu;i++)fprintf(fp,"%5d %9.3f %9.3f\n",un[i],ux[i],uy[i]);
  fclose(fp);
  sprintf(t,"u_phot4k %s",f1); system(t);
// produce a*.uap
  ap2uap(f1);
// readin a*.uap
  sprintf(f2,"%s.uap",f1); fp1=fopen(f2,"r");
l101:
  fgets(a,220,fp1); if(a[0]=='#')goto l101;
  for(i=0;i<nu;i++){
    sscanf(a,"%d",&j);
    if(j!=un[i]){ printf("%d: un: %d  uap: %d\n",i,un[i],j); 
                          fclose(fp1);     exit(0); }
    sscanf(&a[22],"%f",&d1[i]); sscanf(&a[101],"%f %f",&d2[i],&d3[i]);
    fgets(a,220,fp1);
  } fclose(fp1);
  printf("===> %s\n",f2);
// readin b_a*.fit
  sprintf(t,"b_%s.fit",f1); fp=fopen(t,"rb"); fseek(fp,72*80,0);
  fread(b_fit,n1,n2,fp); fclose(fp);
// produce *.cat
  sprintf(f2,"main.cat",f1); fpp=fopen(f2,"w"); puthead(fpp);

// append a*.sex
  sprintf(f2,"%s.sex",f1); fp1=fopen(f2,"rb");
  for(i=0;i<nu;i++){
    k=ux[i]+0.5; j=uy[i]+0.5;
    l=b_fit[j][k];  zz=um[i];
    dx=ux[i]; dy=uy[i]; 
    if(un[i]>60000)ux[i]=uy[i]=0.;
    xy_rad(a8[6],a8[7],dx,dy,&alpha,&delta,1,0);
    toms2(alpha,c1,1); toms2(delta,c2,0);
    s2=s3=s4=s5=s6=s7=s8=s9=sb=sc=sd=se=r=0.; sa=0;
    k=-1; for(j=0;j<nb;j++)if(bn[j]==i){ k=j; break; }
    if(k>=0){  r=bz[k]; if(un[i]>60000){ r=0.; zz=bz[k]; } 
      fseek(fp1,k*113+2,0);
      fread(a,1,220,fp1);            // a*.sex
      sscanf(a,"%f %f %f %f %f %f %f %f %d %f %f %f %f",
        &s2,&s3,&s4,&s5,&s6,&s7,&s8,&s9,&sa,&sb,&sc,&sd,&se);
      sa&=0x3f;             if(sc<90.)sc+=cali;
      if(sd>9.99)sd=9.99;   if(se>99.99)se=99.99;
      if(s3>9.999)s3=9.999; if(s8>999.99)s8=999.99; if(s8<-99.99)s8=-99.99;
      if(s7>9.99)s7=9.99;
    }
    fprintf(fpp,"%5d %s %s%8.2f%8.2f%8.2f%8.2f%8.2f%7.3f%6.3f",
      un[i],c1,c2,ux[i],uy[i],s4,s5,d1[i],d2[i],d3[i]);
    fprintf(fpp,"%8.2f%7.3f%6.3f%7.3f%6.3f%6.2f%5.2f%7.2f%5.2f%6.1f%3d",
                  s6,  s2,  s3,  sc,  sd,  se,  sb,  s8,  s7, s9,   sa);
// pic_num, match_err, usl_mess
    fprintf(fpp,"%3d%5.2f%7.3f\n",l,r,um[i]);
  } 
  fclose(fp1); fclose(fpp);

// append usl_message, combine times. p_err
  fp=fopen("main.cat","r");
  sprintf(f2,"%s.cat",f1); fpp=fopen(f2,"w");
// ka~main.usl;  kb~supply.usl
  ka=kb=0;
  sprintf(f2,"%s.usl",f1); fp2=fopen(f2,"w");
l210:
  fgets(b,170,fp);  if(feof(fp))goto l220;
  if(b[0]=='#'){ fprintf(fpp,"%s",b); goto l210; }
  sscanf(b,"%d",&j);
  if(j<49000){ 
    if(ka==0){ fp1=fopen("main.usl","r"); ka=1;
      fgets(a,220,fp1); fprintf(fp2,"%s",a);
      fgets(a,220,fp1); fprintf(fp2,"%s",a);
    }
l230:
    fgets(a,220,fp1);
    sscanf(a,"%d",&k); if(j!=k)goto l230;
    sscanf(&a[32],"%lld",&a64);
    k=strlen(b); b[k-1]=0;
    fprintf(fpp,"%s%20lld %c\n",b,a64,a[78]);
    fprintf(fp2,"%s",a);
    goto l210;
  }
  if(j<60000){
    if(kb==0){ if(ka){ fclose(fp1); ka=0; }
               fp1=fopen("supply.usl","r"); kb=1; }
    fgets(a,220,fp1);
    sscanf(a,"%d",&k); if(j!=k){ printf("wrong in supply.usl\n"); 
                       fclose(fp); fclose(fpp); fclose(fp2); fclose(fp1);
                                     exit(0); }
    sscanf(&a[32],"%lld",&a64);
    k=strlen(b); b[k-1]=0;
    fprintf(fpp,"%s%20lld %c\n",b,a64,a[78]);
    fprintf(fp2,"%s",a);
    goto l210;
  }
  fprintf(fpp,"%s",b);
  goto l210;
l220:
  fclose(fp); fclose(fpp); fclose(fp2);
  if(kb)fclose(fp1);
  printf("===> %s\n",f2);
  printf("\n\t****** CAT OK ! ********\n");
  exit(0);
}

puthead(FILE *fpp)
{
  int  i,j,k,ip=0;
  char f2[60],a[160];
  FILE *fp;
  fp=fopen("headcat1.par","r");
  if(fp==0){ printf(" Cannot found headcat1.par!\n"); exit(0); }
l10:
  fgets(a,160,fp); if(feof(fp))goto l20;
  if(a[0]<=32)goto l10;
  if(a[0]=='#'){
    if(a[1]!=32 || a[2]!='1')fputs(a,fpp);
    goto l10;
  }
// clear head[72][80];
  for(i=1;i<=10;i++)if(head[i][32]==32)for(j=33;j<60;j++)head[i][j]=32;
  for(i=0;i<72;i++){
    for(j=0;j<strlen(a)-1;j++)if(head[i][j]!=a[j])goto l15;
    k=32; if(i==29)k=79;    // CALIBRAT line
    fputc('#',fpp); fwrite(&head[i][0],1,k,fpp);
    if(ip==0)fwrite(&head[0][32],1,40,fpp);
    if(ip>0 && ip<7)
      { fwrite(&head[ip*2-1][32],1,48,fpp); fwrite(&head[ip*2][32],1,48,fpp); }
    fprintf(fpp,"\n"); ip++;
    goto l10;
l15:;
  }
  goto l10;
l20:
  fclose(fp);
}

ap2uap(char *f1)
{
  FILE *fp2,*fp3;
  int i,k,d[12];
  char a[180],b[220],f2[60],f3[60];
  float x,y,s1,s2,s3,s[12],t[12];

  fp2=fopen("bok.par","r");
  if(fp2==0){ printf("bok.par not found!\n"); exit(0); }
  for(i=0;i<20;i++)fgets(a,180,fp2);
l10:
  fgets(a,180,fp2); if(a[0]!='*')goto l10;
  i=0;
l11:
  fgets(a,180,fp2);
  sscanf(&a[32],"%f",&x);
  d[i++]=x+0.1;
  if(i!=12)goto l11;
  fclose(fp2);
  strcpy(f2,f1); strcat(f2,".ap");
  strcpy(f3,f1); strcat(f3,".uap");
  fp2=fopen(f2,"r"); if(fp2==0){ printf("%s not found!\n"); exit(0); }
  fp3=fopen(f3,"w");
  fprintf(fp3,"# 1 number        i5    ( 'Bertin_Sex' workout )\n");
  fprintf(fp3,"# 2 Ber_x         f8.2  (pixles)    \n");
  fprintf(fp3,"# 3 Ber_y         f8.2  (pixles)    \n");
  fprintf(fp3,"# 4 DAO_phot_sky  f8.2  (adu/pixel) \n");
  fprintf(fp3,"# 5 sky_err       f6.2  (adu)\n");
  for(i=0;i<12;i++){
    fprintf(fp3,"#%2d photo_mag     f7.3 ( RADIUS OF APERTURE %2d )\n",i*2+6,d[i]);
    fprintf(fp3,"#%2d mag_err       f6.3 (mag)\n",i*2+7);
  }
  fprintf(fp3,"#\n");
  for(i=0;i<3;i++)fgets(a,180,fp2);
l20:
  fgets(a,180,fp2); if(feof(fp2))goto l30;
  fgets(a,180,fp2); fgets(b,220,fp2);
  sscanf(a,"%d%f%f%f%f%f%f%f%f%f%f%f%f%f%f",&k,&x,&y,
  &t[0],&t[1],&t[2],&t[3],&t[4],&t[5],&t[6],&t[7],&t[8],&t[9],&t[10],&t[11]);
  sscanf(b,"%f%f%f%f%f%f%f%f%f%f%f%f%f%f%f",&s1,&s2,&s3,
  &s[0],&s[1],&s[2],&s[3],&s[4],&s[5],&s[6],&s[7],&s[8],&s[9],&s[10],&s[11]);
  for(i=0;i<12;i++)if(t[i]<90.)t[i]+=cali;
  for(i=0;i<12;i++)if(s[i]>9.999)s[i]=9.999;
  if(s2>99.99)s2=99.99;
  fprintf(fp3,"%5d%8.2f%8.2f%8.2f%6.2f",k,x,y,s1,s2);
  for(i=0;i<12;i++)fprintf(fp3,"%7.3f%6.3f",t[i],s[i]);
  fprintf(fp3,"\n");
  goto l20;
l30:
  fclose(fp3);
}

xliu(char *f1,int k12,float *xy)
{
  int i,j,k,m=257;
  char h[72][80],t[80];
  FILE *fp2;
  float d[257][257],e[21*21],x,w,sky;
  sprintf(t,"%s_star_%d.fit",f1,k12);
  fp2=fopen(t,"rb"); fread(h,72,80,fp2); fread(d,m*m,4,fp2); fclose(fp2);
  swap4(d,m*m*4); k=0;
  for(j=118;j<=138;j++)for(i=118;i<=138;i++)e[k++]=d[j][i];
  for(i=0;i<k-1;i++)for(j=i+1;j<k;j++)if(e[i]>e[j]){
    x=e[i]; e[i]=e[j]; e[j]=x;
  } sky=e[k/2];
  for(j=127;j<=129;j++)for(i=127;i<=129;i++){
    x=d[j][i]-sky; if(x<0.)x=0.; d[j][i]=x;
  }
  x=d[128][128]*2.+d[127][128]+d[129][128]+d[128][127]+d[128][129];
  sscanf(&h[29][71],"%f",&w);
  *xy=x/w;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

toms2(aa,c,k)
double aa;           // input
char c[14];          // output
int k;               // input
{
  int  i,j;
  double a,b,x;
  a=aa;
  if(k==1){ if(a>24.)a-=24.; if(a<0.)a+=24.; }
  c[0]=32; if(a<0.){ a=-a; c[0]='-'; }
  i=a; b=(a-i)*60.;
  j=b; x=(b-j)*60.;
  if(j==60){ j=0; i++; }
  if(k==1)sprintf(&c[1],"%2.2d:%2.2d:%6.3f",i,j,x);
  if(k==0)sprintf(&c[1],"%2.2d:%2.2d:%5.2f",i,j,x);
  if(c[7]==32)c[7]='0';   if(c[8]==32)c[8]='0';
  if(c[7]=='6'){
    c[7]='0'; j++; sprintf(&c[4],"%2.2d",j);
    if(c[4]=='6'){
      c[4]='0'; i++; sprintf(&c[1],"%2.2d",i);
    }
    c[3]=':'; c[6]=':';
  }
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}

rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[20];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

